/* Ioannou Spiros - Tavernarakis Costas */

#include "config.h"
#include <syslog.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <poll.h>
#include <string.h>
#include <stropts.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <errno.h>
#include <grp.h>
#include <limits.h>

/*SEE config.h for theese options*/

#ifndef MODEMGRP
#define MODEMGRP "modem"
#endif

#ifndef TIMEPERDAY
#define TIMEPERDAY 10800
#endif


 char buffer[1000];
 char buffer2[1000];
 const char * nl="\n";
 int lsd,lsd_b, a, b, i,Asd,Csd,Tsd,len,we_full;

 struct sockaddr_in sa, in_sa,sc,in_sc;
 unsigned char in[2];
 struct hostent *chost;
 int ltc[8]; /*lines to clear*/
 int line[8]; /*line in use (=0) lines not in use (=-1) lines in ltc (=1)*/


 line_s linetable[8];
 line_s TOTSECS[8];

void alarm_handler(int arg)
{
#ifdef TESTING
     printf("Got alarm, will exit\n");
#endif
     syslog(LOG_NOTICE,"-215:ctq error: timed out (alarm)");
     exit(9);
}

void notify_for_bad(char *username) {
     syslog(LOG_NOTICE,"-225:Duplicate modem user:%s",username);
#ifdef TESTING
    printf("BAAAAAD: %s\n",username);
#endif
    
}

main (int argc,char *argv[])
{
 

int noclear=0;
int doit=0;
 Csd=-1;

 if (argc==2) noclear=1;
 else noclear=0;


 /* Set an inactivity alarm, it may hang, nobody's perfect*/
 alarm(60);
 signal(SIGALRM,alarm_handler);
 openlog("ctq", LOG_PID, LOG_AUTH);
 if (connectC("hydra.softlab.ece.ntua.gr.",79)<0) { /*finger*/
     syslog(LOG_NOTICE,"-220:cannot connect to hydra port 79");
  }
#ifdef TESTING
  else printf("main:Connected\n");
#endif
 /*Initialize linetable*/
 for (i=0;i<8;i++) {
     linetable[i].num=0;
     linetable[i].ismember=0;
     linetable[i].isbad=0;
     TOTSECS[i].num=0;
     ltc[i]=0;
     line[i]=-1;
 };

#ifdef TESTING
printf("Before getlines\n");
#endif
 /*Create linetable table*/
 getlines();
#ifdef TESTING
printf("After getlines\n");
#endif


 /*Create ltc (lines to clear) table*/
#ifdef TESTING
printf("Before parselines\n");
#endif
 parselines();
#ifdef TESTING
printf("After parselines\n");
#endif

 /*Close finger connection*/
 shutdown(Csd,2);
 close(Csd);

 if (noclear) {
     showltc();
     exit(0);
 }
  for (i=0;i<8;i++)
     if (line[i]==1) doit++;

  if (!doit) exit(0);

 

 /*Reconnect to clear lines*/
 if (connectC("hydra.softlab.ece.ntua.gr.",23)<0) { /*telnet*/
     syslog(LOG_NOTICE,"-221:cannot connect to hydra port 23");
     exit(3);
  }

 /*Clear the lines*/
 if (enable()<0) {
     syslog(LOG_NOTICE,"-222:cannot enable to hydra");
 };
 for (i=0;i<8;i++) 
     if (ltc[i]>0) {
       warnline(ltc[i]);
     }
 
 sleep(5);
 for (i=0;i<8;i++) 
     if (ltc[i]>0) {
       clearline(ltc[i]);
     }
 shutdown(Csd,2);
 close(Csd);

}

parselines()
{
 char *lepa[100];
 int match,i,j,k;
 struct group *gp;

 k=1;
 lepa[0]="ex_tac_main";
 for (i=0;i<8;i++) {
     if (linetable[i].num) {

	 /*Check if user a member of MODEMGRP*/
	 match=0;
	 line[linetable[i].num - 1]=0; /*user is in*/
	 if ((gp = getgrnam(MODEMGRP)) != NULL) {
	    for (j = 0;(j<NGROUPS_MAX) && gp->gr_mem[j]; ++j)
		if (!strcmp(gp->gr_mem[j],linetable[i].username)) {
		   match++;
		   break;
	        }
	    if (match)  {
		linetable[i].ismember=1;
		continue;
	    }
	 } 
 
	 /*End of group checking*/
	     
         /*Update our TOTSECS(=seconds since last roll over) variable*/
	
	 lepa[k]=(char *)malloc(sizeof (linetable[i].username));
	 strcpy(lepa[k],linetable[i].username);
#ifdef TESTING
         printf("Argument lepa[%d]=%s\n",k,lepa[k]);
#endif

         k++;
     } /*if*/
     else linetable[i].username[0]=NULL;
  } /*for*/

 for (i=0;i< 8;i++) 
    for (j=i+1;j<8;j++){
        if (linetable[i].num && linetable[j].num && !linetable[i].ismember &&
            !strcmp(linetable[i].username,linetable[j].username)) {
            linetable[i].isbad=1;
	    notify_for_bad(linetable[i].username);
        }

    } /*for*/

 lepa[k]=NULL;
 if (k<=1) return  2;
 updatetotsecs(k,lepa);

 /*His time is out*/

 for(k=0,i=0;k<8 && TOTSECS[k].num ;k++) {
    if (TIMEPERDAY < (TOTSECS[k].num + 600)) {
#ifdef TESTING
        printf("CUT OUT user %s time:%ld\n",
                TOTSECS[k].username,TOTSECS[k].num+600);
#endif
        for(j=0;j<8;j++) {
	    if (!strcmp(linetable[j].username,TOTSECS[k].username)) {
		ltc[i++]=linetable[j].num;
		line[linetable[j].num - 1]=1; /*user is in, and shoud be out*/
            }
	}
#ifdef TESTING
	for(j=0;j<8;j++) 
	    if (ltc[j]) printf("Line:%d\n",ltc[j]);
#endif
    }
    else {
#ifdef TESTING
	printf("LEAVE IN user %s time:%ld\n",TOTSECS[k].username,
		TOTSECS[k].num+600);
#endif
    }
 } /*for*/
} /*parselines*/

getlines()
{
 char *coco,coco2[40];

  if (Csd) {
      write(Csd,nl,sizeof(nl));
      b=1;
      bzero(buffer2,sizeof(buffer2));
      bzero(buffer,sizeof(buffer));
      while (b || errno==EAGAIN){
	  b=read(Csd,buffer2,sizeof(buffer2));
	  if (b>0) {
	      strcat (buffer,buffer2); 
	  }
      }
  }
  else return(-1);

  i=0;
    if (coco=strstr(buffer," tty ")){
      do {
	  bzero(coco2,sizeof(coco2));
	  strncpy(coco2,coco,18);
	  if (2==sscanf(coco2,"%*s%d%s",&linetable[i].num,linetable[i].username)) {
#ifdef TESTING
	  printf("%d - Num:%d,username:%s\n",i,linetable[i].num,
		  linetable[i].username);
#endif /*TESTING*/
		i++; 
	  }
	  else linetable[i].num=0;
	  coco=strstr(++coco," tty ");
      } while(coco && i<=8);
    }
}

connectC(const char * host,int port)
{
/*Open C socket and connect to C host*/

	if ((Csd = socket (AF_INET, SOCK_STREAM, 0)) < 0) {
	  /*perror ("Can't open C socket");
	  exit (-1);*/
	  return (-1);
	}
	sc.sin_port = htons ((u_short) port);

	 chost = gethostbyname (host);
         if (!chost) return (-2);
#ifdef TESTING
	 printf ("\nC address : %s %d \n" , inet_ntoa (chost->h_addr),
		 ntohs(sc.sin_port)); 

#endif
	 sc.sin_family = AF_INET;
	 memcpy (&sc.sin_addr, chost->h_addr, chost->h_length);

	if (connect (Csd,(struct sockaddr *) &sc, sizeof (sc)) < 0) {
	  /*perror ("Can't connect to C");*/
	  return (-3);
	}
#ifdef TESTING
	else printf("Connected to C\n");
#endif
       return (1); 
}

enable()
{
int c=0;
char *s;

 c=0;
 do {
     c++;
     b=read(Csd,buffer,sizeof(buffer));
#ifdef TESTING
     printf("Buf:#%s#\n",buffer);
#endif
 } while (c<10&&!strstr(buffer,"Password: ")) ;


 bzero(buffer,sizeof buffer);
 strcpy(buffer,"c0caco1a\n");
#ifdef TESTING
 printf("\nWill write cocacola\n");
#endif
 sleep(1);
 slowrite(Csd,buffer,strlen(buffer));
#ifdef TESTING
 printf("\nWritten:%s\n",buffer);
#endif

 c=0;
 do {
     c++;
     b=read(Csd,buffer,sizeof(buffer));
#ifdef TESTING
     printf("Buf:%s\n",buffer);
#endif
 } while (c<10 && !(s=strstr(buffer,">"))) ;

 if (!s) {
#ifdef TESTING
   printf(">: not found!\n");
#endif
   return(-1);
 }

 bzero(buffer,sizeof buffer);
 strcpy(buffer,"\nen\n");
#ifdef TESTING
 printf("\nWill write en\n");
#endif
 sleep(1);
 slowrite(Csd,buffer,strlen(buffer));
#ifdef TESTING
 printf("\nWritten:%s\n",buffer);
#endif

 c=0;
 do {
     c++;
     b=read(Csd,buffer,sizeof(buffer));
#ifdef TESTING
     printf("Buf:%s\n",buffer);
#endif
 } while (c<10 && !(s=strstr(buffer,"Password: "))) ;

 if (!s) {
#ifdef TESTING
   printf("Password not found!\n");
#endif
   return(-2);
 }
 
 bzero(buffer,sizeof buffer);
 strcpy(buffer,"D3adM1lk\n");
#ifdef TESTING
 printf("\nWill write enable password\n");
#endif
 sleep(1);
 slowrite(Csd,buffer,strlen(buffer));
#ifdef TESTING
 printf("\nWritten:%s\n",buffer);
#endif



 c=0;
 do {
     c++;
     b=read(Csd,buffer,sizeof(buffer));
#ifdef TESTING
     printf("Buf:%s\n",buffer);
#endif
 } while (c<10 && !(s=strstr(buffer,"#"))) ;

 if (!s) {
#ifdef TESTING
   printf("Cannot enter privileged mode\n");
#endif
   return(-3);
 }
#ifdef TESTING
 else printf("\nEnabled!\n\n");
#endif
 return (1);
}

clearline(int line)
{

#ifdef TESTING
 printf("Will clear line %d\n",line);
#endif
 sprintf(buffer,"clear line %d\n\n",line);
 slowrite(Csd,buffer,strlen(buffer));

 bzero(buffer,sizeof buffer);

 b=read(Csd,buffer,sizeof(buffer));
#ifdef TESTING
 printf(buffer);
#endif

}

warnline(int line)
{
#ifdef TESTING
 printf("Will warn line %d\n",line);
#endif
 sprintf(buffer,"send %d\n",line);
 slowrite(Csd,buffer,strlen(buffer));
 sprintf(buffer,"***\n*** Message from root to you:\n\nDear user, your time is over,\nyou will be logged out in a few seconds,\nPlease finish your work.\n");
 write(Csd,buffer,strlen(buffer));
 sprintf(buffer,"***\n%c\n\n",26);
 slowrite(Csd,buffer,strlen(buffer));
 bzero(buffer,sizeof buffer);
 b=read(Csd,buffer,sizeof(buffer));
#ifdef TESTING
 printf("%s\n",buffer);
#endif
}

usleep(useconds_t x) {
        struct timeval  time;

        time.tv_sec= x/1000000;
        time.tv_usec=x%1000000;
        select(0, NULL, NULL, NULL, &time);
}


slowrite(int sd,char * buf,int bs)
{
int i;

    for (i=0;i<bs;i++){
	usleep(100000);
	write(sd,buf+i,sizeof(*buf));
    }
}

showltc()
{
 printf("\nLines to clean: ");
 for (i=0;i<8;i++)
     if (line[i]==1) 
	printf("%d ",i+1);
 printf("\nLines to leave: ");
 for (i=0;i<8;i++)
     if (line[i]==0)
	printf("%d ",i+1);
 printf("\nUnused  lines : ");
 for (i=0;i<8;i++)
     if (line[i]==-1)
	printf("%d ",i+1);
 printf("\n");

}

updatetotsecs(int argc,char *argv[])
{
char * cmdh="/opt/tacacs/bin/taclast -tt ";
char * cmdt="| /bin/awk 'NR==4 {print $4}'";
char  cmd[256];
char buf[1024];
FILE *cmdptr;
int i;
long tsecs;

	for (i=1;i<argc;i++) {
	    strcpy(cmd,cmdh);
	    strcat(cmd,argv[i]);
	    strcat(cmd,cmdt);
	    if ((cmdptr = popen(cmd, "r")) == NULL){
		syslog(LOG_NOTICE,"-425:popen error");
		exit(-4);
	    }
	    fgets(buf, 1024, cmdptr) ;
	    pclose(cmdptr);
	    tsecs=atol(buf);
#ifdef TESTING
	    printf("User:%s,Tsecs:%ld\n",argv[i],tsecs);
#endif
	    TOTSECS[i-1].num=tsecs;
	    strcpy(TOTSECS[i-1].username,argv[i]);
	}

}
